      PROGRAM HLPTOHTML
C Read .HLP file, convert to .HTML hierarchy
C A.Daviel, TRIUMF,  16-FEB-1994 <advax@triumf.ca>
C
C Modifications:
C   1) Allyn Tennant <allyn.tennant@msfc.nasa.gov> some Fortran cleanup,
C      bug fixes, and should now generate HTML that htmlcheck says
C      is clean 1995-Oct-11.
C---
C Logical Unit assignments:
C  1                 Input .hlp file
C  2                 Output .href file
C 10 to 10+MAXLEVEL  Assigned to output .html files, one per level.
C---
C This is a modified version of the program, please use the original
C from the URL indicated below.
C---
C <html>
C <a href="ftp://sundae.triumf.ca/pub2/hlptohtml/hlptohtml.html">HLPTOHTML</a>
C </html>

      IMPLICIT NONE
      INTEGER ITAB,III
      PARAMETER (ITAB=9)

      CHARACTER*66 descrip(21)
      DATA descrip/
     &   'HLPTOHTML: This program converts Digital''s DCL HELP files ',
     &   '(.HLP suffix) to HTIML, the Hypertext Markup Language used',
     &   'on the Web. Separate files are produced for different levels',
     &   'in the HELP hierarchy, preserving the hierarchical nature',
     &   'of the Help information, and allowing use of the browser''s',
     &   'BACK command. The Hypertext ouput may be generated with the',
     &   'pre-formatted flag set (<pre>); the user may remove this',
     &   'and refine the presentation after conversion. Alternatively,',
     &   'pairs of <pre> and </pre> directives may be pre-inserted',
     &   'in the HELP file to protect tables, etc., and formatted',
     &   'output produced (the default).',
     &   ' ',
     &'Usage : the program expects a Help file prefix, eg. "FOOBAR".',
     &   'It will then read FOOBAR.HLP, creating the Hypertext files',
     &'FOOBAR.HTML,FOOBAR_1.HTML,FOOBAR_2.HTML, etc. plus FOOBAR.HREF,',
     &   'a list of the references created which may be used to add',
     &   'further cross-references manually.',
     &   'Depending on the format of the original HLP file, the',
     &   'hypertext output may start either in FOOBAR.HTML or in',
     &   'FOOBAR_1.HTML.', ' '/
      INTEGER MAXLEVEL
      PARAMETER (MAXLEVEL=9)    ! max. no. of levels in HLP file
C
      CHARACTER*256 line, line2,line3
      CHARACTER*132 title
      CHARACTER*80 filenm
      CHARACTER*30 prefix
      CHARACTER*80 word, words(MAXLEVEL)
      CHARACTER*34 part, parts(MAXLEVEL)
      CHARACTER*7 ref
      CHARACTER*8 DATE,TIME
      CHARACTER*1 pre_flag
      INTEGER wns(MAXLEVEL)
      INTEGER ios, level, prev_level, k, j
      INTEGER wn, fln, pxn, tn
      INTEGER partn, nl, refn
      INTEGER nch, nquotes
C The qpre flag is .TRUE. if a "<pre>" (preformat) command has been
C written to the output file and is active.  Several HTML commands are
C not legal inside a <pre>...</pre> block, so we must track this state.
      LOGICAL qpre
C The </dir> command can only be issued if <dir> was issued somewhere
C in the current file.  Hence its status must be tracked on a per level
C basis.
      LOGICAL qdir(0:MAXLEVEL)
*** Added declarations (RV 11/11/98).
       integer mxtab,mxref
       parameter(mxtab=10,mxref=2000)
       integer tabpos(mxtab),ntab,tabrow,i,j0,j1,
     -      list_indent,list_level,nch2,nch3,nskip,nref,ncref(mxref),
     -      nchref(mxref),ncaname(mxref),iarr,iend,nsub,
     -      ncback(0:maxlevel),ncbackstr(0:maxlevel),ndir(0:maxlevel),
     -      nl_input,nl_output,ntable,nul,nol,ndl,defpos(2),defrow,
     -      count_header(MAXLEVEL),nc_header
       character*6 tabali(mxtab)
       character*256 refstr(mxref),href(mxref),aname(mxref),
     -      back(0:maxlevel),backstr(0:maxlevel),string_header
       logical table,list,tabind(mxtab),tabpre(mxtab),tabsub(mxtab),
     -      deflist
*** End of additions.
       DATA qdir/.FALSE.,MAXLEVEL*.FALSE./
*** Start header count.
       do i=1,maxlevel
       count_header(i)=0
       enddo
*** Initialisations: open main file.
       prefix='garfield'
       pxn=8
       open(unit=1,file=prefix(:pxn)//'.hlp',status='old',
     -      iostat=ios,err=2010)
 2010  continue
       if(ios.ne.0)then
            print *,' !!!!!! Unable to open file: ',prefix(:pxn)//'.hlp'
            stop
       endif
*   Open index file.
       open(unit=2,file=prefix(1:pxn)//'.href',status='new')
*   Open toc file.
       open(unit=3,file=prefix(1:pxn)//'_toc.html',status='new')
       write(3,'(
     -      ''<HTML>''/
     -      ''<HEAD><TITLE>Table of contents Garfield help</TITLE>'',
     -      ''</HEAD>''/
     -      ''<BODY BGCOLOR=#E0E0FF>''/
     -      ''<TABLE BGCOLOR="#FFFF99" WIDTH="100%"'',
     -         '' BORDER=0 CELLSPACING=0 CELLPADDING=0>''/
     -      ''<TR ALIGN=left>''/
     -      ''<TD>'',
     -      ''<A HREF="http://www.cern.ch/">''/
     -         ''<IMG SRC="/icons/itx/cern.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch">''/
     -         ''<IMG SRC="/icons/itx/consult.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeups">''/
     -         ''<IMG SRC="/icons/itx/writeups.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>'')')
       write(3,'(
     -      ''<A HREF="http://consult.cern.ch/writeup/garfield">''/
     -         ''<IMG SRC="/icons/writeups/garfield.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeup/garfield/help">''/
     -         ''<IMG SRC="labels/Help.gif"'',
     -            '' ALT="Help pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Help pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -         ''<IMG SRC="labels/toc.gif"'',
     -            '' ALT="This page" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/r-c.gif"'',
     -            '' ALT="This page" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</TD>''/
     -      ''<TD ALIGN=right>''/
     -      ''<A HREF="ref.html">''/
     -         ''<IMG SRC="labels/index_na.gif" ALT="Keyword index"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="garfield_full.html">''/
     -         ''<IMG SRC="labels/full_text_na.gif" ALT="Full text"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''</TD></TR>''/''</TABLE>''/
     -      ''<H1><FONT COLOR=red>Garfield help pages, table'',
     -         '' of contents</FONT></H1>''/
     -      ''<UL>'')')
*   Preformatted or not.
       pre_flag='N'
       qpre = .FALSE.
*   Levels.
       prev_level = 1
       level = 1
       parts(1)='garfield'
       partn = 0
       refn = 0
       nquotes = 0
*   Open a file for the full document.
       open(unit=4,file=prefix(1:pxn)//'_full.temp',status='new')
       write(4,'(
     -      ''<HTML>''/
     -      ''<HEAD><TITLE>Complete Garfield help file</TITLE>'',
     -      ''</HEAD>''/
     -      ''<BODY BGCOLOR=#E0E0FF>''/
     -      ''<TABLE BGCOLOR="#FFFF99" WIDTH="100%"'',
     -         '' BORDER=0 CELLSPACING=0 CELLPADDING=0>''/
     -      ''<TR ALIGN=left>''/
     -      ''<TD>'',
     -      ''<A HREF="http://www.cern.ch/">''/
     -         ''<IMG SRC="/icons/itx/cern.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch">''/
     -         ''<IMG SRC="/icons/itx/consult.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeups">''/
     -         ''<IMG SRC="/icons/itx/writeups.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>'')')
       write(4,'(
     -      ''<A HREF="http://consult.cern.ch/writeup/garfield">''/
     -         ''<IMG SRC="/icons/writeups/garfield.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeup/garfield/help">''/
     -         ''<IMG SRC="labels/Help.gif"'',
     -            '' ALT="Help pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Help pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -         ''<IMG SRC="labels/full_text.gif"'',
     -            '' ALT="This page" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/r-c.gif"'',
     -            '' ALT="This page" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</TD>''/
     -      ''<TD ALIGN=right>''/
     -      ''<A HREF="garfield_toc.html">''/
     -         ''<IMG SRC="labels/toc_na.gif" ALT="Table of contents"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="ref.html">''/
     -         ''<IMG SRC="labels/index_na.gif" ALT="Keyword index"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''</TD></TR>''/''</TABLE>''/
     -      ''<H1><FONT COLOR=red>Overview</FONT></H1>'')')
*** Create base file
       filenm = prefix // '.temp'
       CALL SQUASH(filenm,fln)
*** Open first level output file.
       backstr(0)='Help'
       ncbackstr(0)=4
       back(0)='http://consult.cern.ch/writeup/garfield/help'
       ncback(0)=44
       call ophtml(10+level,filenm,fln,back,ncback,backstr,ncbackstr,
     -     level, 'Garfield help pages', 19)
*** Initialisation for tables, lists. (RV 11/11/98)
       table=.false.
       list=.false.
       list_indent=3
       list_level=0
       nref=0
       ntable=0
       nul=0
       nol=0
       ndl=0
*** Read a new line and determine the length.
 200   CONTINUE
       READ(1,'(A)',END=900) line
       nl = nl + 1
       do iii=len(line),1,-1
       if(line(iii:iii).ne.' ')then
            nch=iii
            goto 1234
       endif
       enddo
       nch=1
 1234  continue
*** Special processing for "!W" lines, first table start. (RV 11/11/98)
       if(line(1:13).eq.'!Wtable_start')then
*   Count tables.
            ntable=ntable+1
*   Read the line with tab positions.
            read(1,'(a)',end=900) line
            nl = nl + 1
            ntab=0
            do i=3,len(line)
            if(line(i:i).eq.'+'.or.line(i:i).eq.'L')then
                 ntab=ntab+1
                 tabpos(ntab)=i
                 tabali(ntab)='left'
                 tabind(ntab)=.false.
                 tabpre(ntab)=.false.
                 tabsub(ntab)=.false.
            elseif(line(i:i).eq.'R')then
                 ntab=ntab+1
                 tabpos(ntab)=i
                 tabali(ntab)='right'
                 tabind(ntab)=.false.
                 tabpre(ntab)=.false.
                 tabsub(ntab)=.false.
            elseif(line(i:i).eq.'C')then
                 ntab=ntab+1
                 tabpos(ntab)=i
                 tabali(ntab)='center'
                 tabind(ntab)=.false.
                 tabpre(ntab)=.false.
                 tabsub(ntab)=.false.
            elseif(line(i:i).eq.'I')then
                 tabind(ntab)=.true.
            elseif(line(i:i).eq.'S')then
                 tabsub(ntab)=.true.
            elseif(line(i:i).eq.'P')then
                 tabpre(ntab)=.true.
            elseif(line(i:i).eq.'.')then
                 tabpos(ntab+1)=i
            elseif(line(i:i).ne.' '.and.line(i:i).ne.'I')then
                 print *,' !!!!!! Saw invalid tab marker, line ',nl
                 print *,line
            endif
            enddo
            table=.true.
            tabrow=0
            write(10+level,'(''<TABLE BORDER=1>'')')
            write(4,'(''<TABLE BORDER=1>'')')
            goto 200
**  End of table.
       elseif(line(1:11).eq.'!Wtable_end')then
            write(10+level,'(''</TABLE>'')')
            write(4,'(''</TABLE>'')')
            table=.false.
            goto 200
**  Start of a definition list.
       elseif(line(1:10).eq.'!Wdl_start')then
*   Count such lists.
            ndl=ndl+1
*   Read the line with tab positions.
            read(1,'(a)',end=900) line
            nl=nl+1
            ntab=0
            do i=3,len(line)
            if(line(i:i).eq.'+')then
                 ntab=ntab+1
                 if(ntab.le.2)defpos(ntab)=i
            elseif(line(i:i).ne.' ')then
                 print *,' !!!!!! Saw invalid tab marker, line ',nl
                 print *,line
            endif
            enddo
            if(ntab.ne.2)print *,' !!!!!! Incorrect number of tab'//
     -           ' positions in <DL>, line ',nl
            deflist=.true.
            defrow=0
*   Write header.
            write(10+level,'(''<DL>'')')
            write(4,'(''<DL>'')')
            goto 200
**  End of definition list.
       elseif(line(1:8).eq.'!Wdl_end')then
            deflist=.false.
            write(10+level,'(''</DL>'')')
            write(4,'(''</DL>'')')
            deflist=.false.
            goto 200
**  Start of an unordered list.
       elseif(line(1:10).eq.'!Wul_start')then
            write(10+level,'(''<UL>'')')
            write(4,'(''<UL>'')')
            nul=nul+1
            list_level=list_level+1
            list_indent=list_indent+2
            list=.true.
            goto 200
**  Start of an ordered list.
       elseif(line(1:10).eq.'!Wol_start')then
            write(10+level,'(''<OL>'')')
            write(4,'(''<OL>'')')
            nol=nol+1
            list_level=list_level+1
            list_indent=list_indent+3
            list=.true.
            goto 200
**  End of an unordered list.
       elseif(line(1:8).eq.'!Wul_end')then
            write(10+level,'(''</UL>'')')
            write(4,'(''</UL>'')')
            list_level=list_level-1
            list_indent=list_indent-2
            if(list_level.le.0)list=.false.
            goto 200
**  End of an ordered list.
       elseif(line(1:8).eq.'!Wol_end')then
            write(10+level,'(''</OL>'')')
            write(4,'(''</OL>'')')
            list_level=list_level-1
            list_indent=list_indent-3
            if(list_level.le.0)list=.false.
            goto 200
**  Delete some lines.
       elseif(line(1:2).eq.'!D')then
            read(line(3:10),'(bn,i8)') nskip
            do i=1,nskip
            nl=nl+1
            read(1,'()',end=900)
            enddo
            goto 200
**  Uncomment the other "!R" lines and process them normally.
       elseif(line(1:2).eq.'!R')then
            line(1:2)='  '
**  Literal copy of !W lines.
       elseif(line(1:2).eq.'!W')then
            if(nch.lt.3)then
                 write(10+level,'(''<P>'')')
                 write(4,'(''<P>'')')
            else
                 write(10+level,'(A)') line(3:nch)
                 write(4,'(A)') line(3:nch)
            endif
            goto 200
**  Ordinary comment lines.
       elseif(line(1:1).eq.'!')then
            goto 200
       endif
*** Process table lines.
       if(table)then
*   Be sure this is not a separator line or a blank line.
            if(line(3:5).eq.'---'.or.line.eq.' ')goto 200
*   Write header.
            write(10+level,'(''<TR>'')')
            write(4,'(''<TR>'')')
*   Keep row count.
            tabrow=tabrow+1
*   Loop over tab positions.
            do i=1,ntab
*   Escape this field.
            call escape(line(tabpos(i):tabpos(i+1)-1),
     -           tabpos(i+1)-tabpos(i),line2,nch2)
*   Find true start and end of this field.
            j0=0
            do j=1,nch2
            if(j0.eq.0.and.line2(j:j).ne.' ')j0=j
            enddo
            j1=0
            do j=nch2,1,-1
            if(j1.eq.0.and.line2(j:j).ne.' ')j1=j
            enddo
*   Fix blank fields.
            if(j0.eq.0.or.j1.eq.0.or.j1.lt.j0)then
                 print *,' !!!!!! Blank element, line ',nl
                 line2='&nbsp;'
                 nch2=6
                 j0=1
                 j1=6
            endif
*   If this is an index field, create a reference string.
            if(tabind(i).and.tabrow.gt.1)then
                 line3='"-&gt; '
                 nch3=7
                 do j=1,level-1
                 line3(nch3+1:)=words(j)(1:wns(j))//' -&gt; '
                 nch3=nch3+wns(j)+7
                 enddo
                 line3(nch3+1:)=line2(j0:j1)//'"'
                 nch3=nch3+j1-j0+1+1
                 line2=line3
                 nch2=nch3
                 j0=1
                 j1=nch2
            endif
*   If this is an subtopic field, create a reference string.
            if(tabsub(i).and.tabrow.gt.1)then
                 line3='"-&gt; '
                 nch3=7
                 do j=1,level
                 line3(nch3+1:)=words(j)(1:wns(j))//' -&gt; '
                 nch3=nch3+wns(j)+7
                 enddo
                 line3(nch3+1:)=line2(j0:j1)//'"'
                 nch3=nch3+j1-j0+1+1
                 line2=line3
                 nch2=nch3
                 j0=1
                 j1=nch2
            endif
*   If this is a pre-formatted field, add the <CODE>.
            if(tabpre(i).and.tabrow.gt.1)then
                 line3='<CODE>'//line2(j0:j1)//'</CODE>'
                 line2=line3
                 nch2=j1-j0+1+13
                 j0=1
                 j1=nch2
            endif
*   Write a header record.
            if(tabrow.eq.1)then
                 write(10+level,'(''<TH ALIGN='',a,''>'',a)') 
     -                tabali(i),line2(j0:j1)
                 write(4,'(''<TH ALIGN='',a,''>'',a)') 
     -                tabali(i),line2(j0:j1)
*   Write an ordinary line.
            else
                 write(10+level,'(''<TD ALIGN='',a,''>'',a)') 
     -                tabali(i),line2(j0:j1)
                 write(4,'(''<TD ALIGN='',a,''>'',a)') 
     -                tabali(i),line2(j0:j1)
            endif
            enddo
*   Read a new line.
            goto 200
**  Process lists.
       elseif(list)then
*   Write an item header if appropriate.
            if(nch.lt.list_indent)then
                 write(10+level,'(''<P>'')')
                 write(4,'(''<P>'')')
            elseif(line(list_indent-2:list_indent-2).ne.' ')then
                 call escape(line(list_indent:nch),nch-list_indent+1,
     -                line2,nch2)
                 write(10+level,'(''<LI>'',A)') line2(1:nch2)
                 write(4,'(''<LI>'',A)') line2(1:nch2)
            else
                 call escape(line(list_indent:nch),nch-list_indent+1,
     -                line2,nch2)
                 write(10+level,'(A)') line2(1:nch2)
                 write(4,'(A)') line2(1:nch2)
            endif
*   Read a new line.
            goto 200
**  Process definition lists.
       elseif(deflist)then
*   Be sure this is not a separator line or a blank line.
            if(line(3:5).eq.'---'.or.line.eq.' ')goto 200
*   Keep row count.
            defrow=defrow+1
*   Skip the first line.
            if(defrow.eq.1)goto 200
*   Write an item header if appropriate.
            if(nch.lt.defpos(2))then
                 write(10+level,'(''<P>'')')
                 write(4,'(''<P>'')')
            elseif(line(defpos(1):defpos(2)-1).ne.' ')then
                 call escape(line(defpos(1):defpos(2)-1),
     -                defpos(2)-defpos(1),line2,nch2)
                 write(10+level,'(''<DT><B>'',A,''</B>'')') 
     -                line2(1:nch2)
                 write(4,'(''<DT><B>'',A,''</B>'')') 
     -                line2(1:nch2)
                 call escape(line(defpos(2):nch),nch-defpos(2)+1,
     -                line2,nch2)
                 write(10+level,'(''<DD>'',A)') line2(1:nch2)
                 write(4,'(''<DD>'',A)') line2(1:nch2)
            else
                 call escape(line(defpos(2):nch),nch-defpos(2)+1,
     -                line2,nch2)
                 write(10+level,'(A)') line2(1:nch2)
                 write(4,'(A)') line2(1:nch2)
            endif
*   Read a new line.
            goto 200
       endif
*** Empty lines.
       if(nch.eq.0.or.line.eq.' ')then
            write(10+level,'(''<P>'')')
            write(4,'(''<P>'')')
            goto 200
       endif
*** Read header levels.
       IF((line(1:1).LT.'1'.OR.line(1:1).GT.'9').OR.
     -      (line(2:2).NE.' '.AND.line(2:2).NE.CHAR(ITAB)))GOTO 300
       READ(line,'(bn,i1)',ERR=300) level
*** Escape header. (RV 11/11/98)
       if(nch.ge.3)then
            word=' '
            call escape(line(3:nch),nch-2,word,wn)
       else
            word=' '
            wn=1
       endif
*** End of modification.
       CALL SQUASH(word, wn)
       wns(level) = wn
       words(level) = word
C      WRITE(*,*) 'Level=',level,', Key="',word(1:wn),'"'
*** When going back to a lower level ...
       if(level.lt.prev_level)then
            if(qpre)then
                 write(10+prev_level,'(''</PRE>'')')
                 qpre=.false.
            endif
*   Close all higher levels.
            do 220 k=prev_level,level+1,-1
            if(qdir(k))then
                 write(3,'(''</UL>'')')
                 if(ndir(k).ne.2*(ndir(k)/2))
     -                write(10+k,'(''<TD>&nbsp;'')')
                 write(10+k,'(''</TR>''/''</TABLE>'')')
                 qdir(k) = .false.
            endif
*   Write a trailing list of backwards pointers (RV 19/11/98).
            write(10+k,'(''<HR>Go to the <A HREF="garfield.html">'',
     -           ''top</A> level,'')')
            do i=1,k-1
            write(10+k,'(''to <A HREF="'',A,''">'',A,''</A>,'')')
     -           back(i)(1:ncback(I)),backstr(i)(1:ncbackstr(i))
            enddo
            write(10+k,'(
     -           ''to the topic <A HREF="ref.html">index</A>''/
     -           ''or to the <A HREF="garfield_toc.html">'',
     -           ''table of contents</A>.'')')
            call datimh(date,time)
            time(3:3)=':'
            if(k.ne.0)then
                 write(10+k,'(''<P>''/''Formatted on '',A8,'' at '',
     -                A5,''.'')') date,time(1:5)
            else
                 write(10+k,'(''<P>''/''<!-- Consulted -->''/
     -              ''Formatted on '',A8,''.'')') date
            endif
*   End of the HTML file and close.
            write(10+k,'(''</BODY>''/''</HTML>'')')
            close(unit=10+k)
220         continue
*   Update the header count.
            count_header(level)=count_header(level)+1
            do i=level+1,maxlevel
            count_header(i)=0
            enddo
*   Restore file name to old level.
            part = parts(level)
            filenm = part // '.temp'
            call squash(filenm,fln)
            write(3,'(''</UL>'')')
            if(ndir(level).ne.2*(ndir(level)/2))
     -           write(10+level,'(''<TD>&nbsp;'')')
            write(10+level,'(''</TR>''/''</TABLE>'')')
            qdir(level)=.false.
*** When going more than 1 level down ...
       elseif(level.GT.prev_level+1 )then
            print *,' ERROR - skipped level in HELP file ',
     -           level,prev_level
            stop
*** When going down just one level.
       elseif(level.gt.prev_level)then
            partn=partn + 1
            write(part,'(a,''_'',i3)') prefix,partn
            parts(level)=part
            filenm=part//'.temp'
            call squash(filenm,fln)
*   Format a title.
            if(level.le.1)then
                 title="Garfield"
                 tn=8
            else
                 title=words(1)(1:wns(1))
                 tn=wns(1)
                 do 240 k=2,level-1
                 title=title(1:tn)//':%'//words(k)(1:wns(k))
                 call squash(title,tn)
240              continue
            endif
*   Keep track of header count.
            count_header(level)=count_header(level)+1
*   Open an HTML file.
            call ophtml(10+level,filenm,fln,back,ncback,backstr,
     -           ncbackstr,level,title,tn)
            if(qpre)then
                 write(10+prev_level,'(''</PRE>'')')
                 qpre=.false.
            endif
*   And start a listing of sub topic at the previous higher level.
            if(level.gt.1)then
                 write(10+prev_level,'(
     -                ''<P>Additional information on:'')')
            else
                 write(10+prev_level,'(
     -                ''<P>Information available on:'')')
            endif
            write(3,'(''<UL>'')')
            write(10+prev_level,'(''<TABLE'',
     -           '' CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>''/
     -           ''<TR><TD WIDTH=50%>&nbsp;<TD WIDTH=50%>&nbsp;</TR>''/
     -           ''<TR>'')')
            ndir(prev_level)=0
            qdir(prev_level)=.true.
**  Staying at the same level.
       elseif(level.eq.prev_level)then
*   Keep track of header count.
            count_header(level)=count_header(level)+1
       endif
*** Increment item counter and format the item reference string.
       refn=refn+1
       write(ref,'(''Ref'',i4.4)') refn
*   Make an anchor by this name.
       if(qpre)then
           write(10+level,'(''</PRE>'')')
           qpre=.false.
       endif
       write(10+level,'(A)') '<HR><FONT COLOR=green><H2><A NAME="'//
     -     ref//'">'//word(1:wn)//'</A></H2></FONT>'
       call hstring(level,count_header,string_header,nc_header)
       if(level.eq.1)then
           write(4,'(A)') '<HR><FONT COLOR=red><H1><A NAME="'//
     -          ref//'">Chapter '//string_header(1:nc_header)//': '//
     -          word(1:wn)//'</A></H1></FONT>'
       elseif(level.eq.2)then
           write(4,'(A)') '<FONT COLOR=green><H2><A NAME="'//
     -          ref//'">Section '//string_header(1:nc_header)//': '//
     -          word(1:wn)//'</A></H2></FONT>'
       elseif(level.eq.3)then
           write(4,'(A)') '<FONT COLOR=brown><H3><A NAME="'//
     -          ref//'">'//string_header(1:nc_header)//': '//
     -          word(1:wn)//'</A></H3></FONT>'
       else
           write(4,'(A)') '<FONT COLOR=black><H4><A NAME="'//
     -          ref//'">'//string_header(1:nc_header)//': '//
     -          word(1:wn)//'</A></H4></FONT>'
       endif
*   Record the file name with anchor for references.
       if(fln.gt.4)filenm(fln-3:fln)='html'
       back(level)=filenm(1:fln)//'#'//ref
       ncback(level)=fln+9
       backstr(level)=word(1:wn)
       ncbackstr(level)=wn
*   Add at the upper level to the list of sub topics.
       if(ndir(level-1).gt.0.and.ndir(level-1).eq.2*(ndir(level-1)/2))
     -      write(10+level-1,'(''</TR><TR>'')')
       write(10+level-1,'(''<TD><UL><LI><A HREF="'',A,''#'',A,
     -      ''">'',A,''</A></UL>'')') filenm(1:fln),ref,word(1:wn)
       ndir(level-1)=ndir(level-1)+1
*   Record in the toc file.
       if(level.eq.1)then
            write(3,'(''<LI>Chapter '',A,'': <A HREF="'',A,''#'',A,
     -           ''">'',A,''</A>'')') string_header(1:nc_header),
     -           filenm(1:fln),ref,word(1:wn)
       else
            write(3,'(''<LI>Section '',A,'': <A HREF="'',A,''#'',A,
     -           ''">'',A,''</A>'')') string_header(1:nc_header),
     -           filenm(1:fln),ref,word(1:wn)
       endif
*   Record in the index file.
       if(level.lt.2)then
            write(2,'(a)') '<LI><A HREF="'//filenm(1:fln)//'#'//
     -          ref//'">'//word(1:wn)//'</A>'//
     -          '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('//
     -          'Chapter '//string_header(1:nc_header)//')'
       else
            tn=wns(1)
            do k=2,level-1
                 title=title(1:tn)//':%'//words(k)(1:wns(k))
                 call squash(title,tn)
            enddo
            write(2,'(a)') '<LI><A HREF="'//filenm(1:fln)//'#'//
     -           ref//'">'//word(1:wn)//'</A>'//
     -           '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;('//
     -           title(1:tn)//
     -           ', Section '//string_header(1:nc_header)//')'
       endif
*** Record the page with the reference string (RV 19/11/98).
       if(nref.gt.mxref)then
            print *,' !!!!!! Exceeding reference buffer'
            stop
       endif
       nref=nref+1
       ncref(nref)=0
       do k=1,level
       refstr(nref)(ncref(nref)+1:ncref(nref)+wns(k)+7)=
     -      words(k)(1:wns(k))//' -&gt; '
       ncref(nref)=ncref(nref)+wns(k)+7
       enddo
       if(ncref(nref).gt.7)ncref(nref)=ncref(nref)-7
       href(nref)=filenm(1:fln)//'#'//ref
       call squash(href(nref),nchref(nref))
       aname(nref)=word(1:wn)
       ncaname(nref)=wn
C       print *,' Reference: "'//refstr(nref)(1:ncref(nref))//'" to '//
C     -      href(nref)(1:nchref(nref))
*** End of modification.
      prev_level = level
      GOTO 200

 300  IF ( level.LT.0 ) GOTO 200
*** Write as-is (RV 11/11/98).
      IF ( (INDEX(line,'<pre>').GT.0 .OR. INDEX(line,'<PRE>').GT.0) .OR.
     &     (INDEX(line,'</pre>').GT.0 .OR. INDEX(line,'</PRE>').GT.0)
     &     .OR. (INDEX(line,'&').EQ.0 .AND. INDEX(line,'>').EQ.0 .AND.
     &     INDEX(line,'<').EQ.0.AND.INDEX(line,'http').EQ.0.AND.
     -     INDEX(line,'\\').EQ.0))THEN
           if(.not.qpre.and.pre_flag.eq.'Y')then
                write(10+level,'(''<PRE>'')')
                write(4,'(''<PRE>'')')
                qpre=.true.
           endif
           if(nch.ge.3)then
                write(10+level,'(a)') line(3:nch)
                write(4,'(a)') line(3:nch)
           else
                write(10+level,'(''<P>'')')
                write(4,'(''<P>'')')
           endif
      else
*   Take care of escaping reserved characters.
           if(.not.qpre.and.pre_flag.eq.'Y')then
                write(10+level,'(''<PRE>'')')
                write(4,'(''<PRE>'')')
                qpre=.true.
           endif
           if(nch.ge.3)then
                call escape(line(3:nch),nch-2,line2,nch2)
                nquotes=nquotes+1
                write(10+level,'(a)') line2(1:nch2)
                write(4,'(a)') line2(1:nch2)
           else
                write(10+level,'(''<P>'')')
                write(4,'(''<P>'')')
           endif
      endif
*   Read next line.
      goto 200
*** End of modification.

 900  CONTINUE
      IF ( qpre ) THEN
         WRITE (10+level,'(''</PRE>'')')
         qpre = .FALSE.
      END IF
      DO 920 k = level, 0, -1
         if(qdir(k))then
            write(3,'(''</UL>'')')
            if(ndir(k).ne.2*(ndir(k)/2))write(10+k,'(''<TD>&nbsp;'')')
            write(10+k,'(''</TR>''/''</TABLE>'')')
            qdir(k)=.false.
         endif
*** Write a trailing list of backwards pointers (RV 19/11/98).
         if(k.gt.0)then
            write(10+k,'(''<HR>''/
     -           ''Go to the <A HREF="garfield.html">top</A> level,'')')
            do i=1,k-1
            write(10+k,'(''to <A HREF="'',A,''">'',A,''</A>,'')')
     -           back(i)(1:ncback(I)),backstr(i)(1:ncbackstr(i))
            enddo
            write(10+k,'(
     -           ''to the topic <A HREF="ref.html">index</A>,''/
     -           ''or to the <A HREF="garfield_toc.html">'',
     -           '' table of contents</A>.'')')
            call datimh(date,time)
            time(3:3)=':'
            write(10+k,'(''<P>''/
     -           ''Formatted on '',A8,'' at '',A5,''.'')')
     -           date,time(1:5)
         else
            write(10,'(''<HR>''/
     -           ''Go to the topic <A HREF="ref.html">index</A>,''/
     -           ''or to the <A HREF="garfield_toc.html">'',
     -           '' table of contents</A>.'')')
            call datimh(date,time)
            time(3:3)=':'
            write(10,'(''<P>''/''<!-- Consulted -->''/
     -           ''Formatted on '',A8,'' at '',A5,''.'')') 
     -           date,time(1:5)
            endif
*** Close intermediate files.
            write(10+k,'(''</BODY>''/''</HTML>'')')
            close(unit=10+k)
*** End of modification.
 920   continue
       close(1)
       close(2)
       write(3,'(''</UL>''/''<HR>''/
     -      ''Go to the <A HREF="garfield.html">top</A> level,''/
     -      ''or to the topic <A HREF="ref.html">index</A>.'')')
       call datimh(date,time)
       time(3:3)=':'
       write(3,'(''<P>''/
     -      ''Formatted on '',A8,'' at '',A5,''.'')') date,time(1:5)
       write(3,'(''</BODY>''/''</HTML>'')')
       close(3)
       write(4,'(''<HR>''/
     -      ''Formatted on '',A8,'' at '',A5,''.'')') date,time(1:5)
       write(4,'(''</BODY>''/''</HTML>'')')
       close(4)
*** Remember input lines.
       nl_input=nl
*** Re-open all files, locating references.
       nsub=0
       nl_output=0
       do i=-1,partn
*   Open input and output.
       if(i.eq.-1)then
            open(unit=1,file='garfield_full.temp')
            open(unit=2,file='garfield_full.html')
            filenm='garfield_full.html'
            fln=18
       elseif(i.eq.0)then
            open(unit=1,file='garfield.temp')
            open(unit=2,file='garfield.html')
            filenm='garfield.html'
            fln=13
       else
            write(filenm,'(a,''_'',i3,''.temp'')') prefix,i
            call squash(filenm,fln)
            open(unit=1,file=filenm(1:fln))
            write(filenm,'(a,''_'',i3,''.html'')') prefix,i
            call squash(filenm,fln)
            open(unit=2,file=filenm(1:fln))
       endif
*   Read a line.
       nl=0
 2030  continue
       read(1,'(a)',end=2000) line
       nl=nl+1
*   Determine the length.
       do j=len(line),1,-1
       if(line(j:j).ne.' ')then
            nch=j
            goto 2050
       endif
       enddo
       nch=1
 2050  continue
*   Look for start of reference.
 2040  continue
       iarr=index(line(1:nch),'"-&gt;')
       if(iarr.eq.0)goto 2020
       iend=iarr+index(line(iarr+1:nch),'"')
       if(iarr+7.gt.iend-1)then
            print *,' !!!!!! Reference not closed'
            print *,'        Line: ',line(1:nch)
            print *,'        File: ',filenm(1:fln),' line ',nl
            goto 2020
       endif
*   Scan the reference pointers.
       do j=1,nref
       if(refstr(j)(1:ncref(j)).eq.line(iarr+7:iend-1))then
            nch2=0
            if(iarr.gt.1)then
                 line2(1:iarr-1)=line(1:iarr-1)
                 nch2=iarr-1
            endif
            line2(nch2+1:nch2+15+nchref(j)+ncaname(j))='<A HREF="'//
     -           href(j)(1:nchref(j))//'">'//aname(j)(1:ncaname(j))//
     -           '</A>'
            nch2=nch2+15+nchref(j)+ncaname(j)
            if(iend.lt.nch)then
                 line2(nch2+1:nch2+nch-iend)=line(iend+1:nch)
                 nch2=nch2+nch-iend
            endif
            line=line2
            nch=nch2
            nsub=nsub+1
            goto 2040
       endif
       enddo
       print *,' !!!!!! Unknown: ',line(iarr+7:iend-1)
       print *,'        File: ',filenm(1:fln),' line ',nl
*   Write the record out after the updates.
 2020  continue
C       if(index(line(1:nch),'-&gt;').ne.0)then
C            print *,' ------ Arrow seen in ',line(1:nch)
C            print *,'        File: ',filenm(1:fln),' line ',nl
C       endif
       write(2,'(a)') line(1:nch)
*   Read a new record.
       goto 2030
*   End of file reached - close both files.
 2000  continue
       if(i.ge.0)nl_output=nl_output+nl
       close(1,status='delete')
       close(2,status='keep')
       enddo
*** Overview counts.
       print *,' Input lines:      ',nl_input
       print *,' Escaped lines:    ',nquotes
       print *,' Output lines:     ',nl_output
       print *,' Output files:     ',partn
       print *,' Headers:          ',nref
       print *,' References:       ',nsub
       print *,' Tables:           ',ntable
       print *,' Ordered lists:    ',nol
       print *,' Unordered lists:  ',nul
       print *,' Definition lists: ',ndl
      END

      subroutine escape(line,nch,line2,nch2)
C Quote HTML reserved characters
      implicit none
      integer j,knext,k,nch,nch2,kk,kend
      character*(*) line,line2
         j = 0
         KNEXT=1
         DO 320 k = 1, nch
         IF(K.LT.KNEXT)GOTO 320
*** Add escape characters (RV 1/9/98).
            IF(K.GT.1.AND.LINE(K-1:K-1).EQ.'\\')THEN
               line2(j+1:j+1)=line(k:k)
               j=j+1
*   Preserve what follows a backslash.
            ELSEIF(LINE(K:K).EQ.'\\')THEN
               GOTO 320
            ELSEIF(K+6.LE.NCH.AND.LINE(K:K+6).EQ.'http://')THEN
C      print *,' ### '//line(1:nch)
               DO 321 KK=K,NCH
               IF(INDEX(' ,()',LINE(KK:KK)).NE.0.OR.
     -              (KK.LT.NCH.AND.LINE(KK:KK+1).EQ.'. ').OR.
     -              (KK.EQ.NCH.AND.LINE(KK:KK).EQ.'.'))THEN
                    KEND=KK-1
                    GOTO 322
               ENDIF
 321           CONTINUE
               KEND=NCH
 322           CONTINUE
C      print *,' Found URL: "'//line(k:kend)//'"'
               LINE2(J+1:J+15+2*(KEND-K+1))='<A HREF="'//
     -              LINE(K:KEND)//'">'//LINE(K:KEND)//'</A>'
               J=J+15+2*(KEND-K+1)
               KNEXT=KEND+1
*** End of addition.
            ELSE IF ( line(k:k).EQ.'&' ) THEN
               line2(j+1:j+5) = '&amp;'
               j = j + 5
            ELSE IF ( line(k:k).EQ.'<' ) THEN
               line2(j+1:j+5) = '&lt;'
               j = j + 4
            ELSE IF ( line(k:k).EQ.'>' ) THEN
               line2(j+1:j+5) = '&gt;'
               j = j + 4
            ELSE
               j = j + 1
               line2(j:j) = line(k:k)
            END IF
 320     CONTINUE
*** Assign new length.
         nch2=j
      end

      SUBROUTINE SQUASH(Word,Nc)
C Remove spaces from char. string
      CHARACTER*(*) Word
      INTEGER Nc

      INTEGER ITAB
      PARAMETER (ITAB=9)

      CHARACTER*132 cooked
      INTEGER nr, k, j

      j = 0
      nr = LEN(Word)
      DO 110 k = 1, nr
*** Added deliberate blanks (RV 8/11/97)
         IF(WORD(K:K).EQ.'%')THEN
            COOKED(J+1:J+6)='&nbsp;'
            j=j+6
*** End of modification.
         ELSEIF( Word(k:k).NE.' ' .AND. Word(k:k).NE.CHAR(ITAB) ) THEN
            j = j + 1
            cooked(j:j) = Word(k:k)
         END IF
 110  CONTINUE
      Nc = j
      IF ( Nc.GT.0 ) Word = cooked(1:Nc)
      RETURN
      END

       SUBROUTINE OPHTML(Lun, Cfile, Lfile, 
     -      back, ncback, backstr, ncbackstr, level,
     -      title, nctitle)
*-----------------------------------------------------------------------
*   OPHTML - Opens an HTML file.
*-----------------------------------------------------------------------
       implicit none
       integer   lun, lfile, level
       character cfile*(*),title*(*)
       integer maxlevel,i,naux,j,jnext,k,nctitle
       parameter (maxlevel=9)
       character*256 back(0:maxlevel),backstr(0:maxlevel),aux
       integer ncback(0:maxlevel),ncbackstr(0:maxlevel)
       logical exist
*** Open the file.
       open(unit=lun,file=cfile(:lfile),status='new')
*** Write the header.
       write(lun,'(''<HTML>''/
     -      ''<HEAD>''/''<TITLE>'',A,''</TITLE>''/''</HEAD>''/
     -      ''<BODY BGCOLOR=#E0E0FF>'')') title(1:nctitle)
*** Generate the Bernd header.
       write(lun,'(''<TABLE BGCOLOR="#FFFF99" WIDTH="100%"'',
     -      '' BORDER=0 CELLSPACING=0 CELLPADDING=0>''/
     -      ''<TR ALIGN=left>''/
     -      ''<TD>'',
     -      ''<A HREF="http://www.cern.ch/">''/
     -         ''<IMG SRC="/icons/itx/cern.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif" ALT="CERN home page"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch">''/
     -         ''<IMG SRC="/icons/itx/consult.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Consult pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeups">''/
     -         ''<IMG SRC="/icons/itx/writeups.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Writeups at CERN" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="http://consult.cern.ch/writeup/garfield">''/
     -         ''<IMG SRC="/icons/writeups/garfield.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -         ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -            '' ALT="Garfield pages" HSPACE=0 VSPACE=0'',
     -            '' ALIGN=left BORDER=0>''/
     -      ''</A>'')')
*** Write the sub topic headers.
       do i=0,level-1
*   Format the label name.
       naux=0
       do 10 j=1,ncbackstr(i)
       if(j.lt.jnext)goto 10
       if(backstr(i)(j:j).eq.'&')then
            do k=j+1,ncbackstr(i)
            if(backstr(i)(k:k).eq.';')then
                 jnext=k+1
                 goto 10
            endif
            enddo
            print *,' End of escape string not found'
       else
            naux=naux+1
            aux(naux:naux)=backstr(i)(j:j)
       endif
10     continue
*   Write out the reference.
       if(i.eq.level-1)then
            write(lun,'(
     -           ''<IMG SRC="labels/'',A,''.gif"'',
     -              '' ALT="This page" HSPACE=0 VSPACE=0'',
     -              '' ALIGN=left BORDER=0>''/
     -           ''<IMG SRC="/icons/itx/r-c.gif"'',
     -              '' ALT="This page" HSPACE=0 VSPACE=0'',
     -              '' ALIGN=left BORDER=0>'')')
     -           aux(1:naux)
       else
            write(lun,'(''<A HREF="'',A,''">''/
     -           ''<IMG SRC="labels/'',A,''.gif"'',
     -              '' ALT="'',A,''" HSPACE=0 VSPACE=0'',
     -              '' ALIGN=left BORDER=0>''/
     -           ''<IMG SRC="/icons/itx/a-rl.gif"'',
     -              '' ALT="'',A,''" HSPACE=0 VSPACE=0'',
     -              '' ALIGN=left BORDER=0>''/
     -           ''</A>'')')
     -           back(i)(1:ncback(I)),aux(1:naux),
     -           backstr(i)(1:ncbackstr(i)),backstr(i)(1:ncbackstr(i))
       endif
*   See whether the icon exists.
       jnext=1
       inquire(file='labels/'//aux(1:naux)//'.gif',
     -      exist=exist)
       if(.not.exist)then
            print *,' Generating ',aux(1:naux)
            call system('labels/t2g '//aux(1:naux)//
     -        ' labels/'//aux(1:naux))
       endif
       enddo
*   End of the left aligned part.
       write(lun,'(''</TD>'')')
*   Index and toc references.
       write(lun,'(''<TD ALIGN=right>''/
     -      ''<A HREF="garfield_toc.html">''/
     -         ''<IMG SRC="labels/toc_na.gif" ALT="Table of contents"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''<A HREF="ref.html">'',
     -         ''<IMG SRC="labels/index_na.gif" ALT="Keyword index"'',
     -            '' HSPACE="0" VSPACE="0" ALIGN=right BORDER=0>''/
     -      ''</A>''/
     -      ''</TD></TR>'')')
*** Close the table.
       write(lun,'(''</TABLE>'')')
*** Write the title.
       write(lun,'(''<H1><FONT COLOR=red>'',A,''</FONT></H1>'')')
     -      title(1:nctitle)
       END

       subroutine hstring(nh,ch,sh,nch)
       implicit none
       integer nh,ch(*),nch,i,nold
       character*(*) sh
       if(nh.lt.1)then
            sh=' '
            nch=0
            return
       endif
       sh=' '
       nch=0
       do i=1,nh
       write(sh(nch+1:nch+5),'(i4,''.'')') ch(i)
       nch=nch+5
       enddo
       nold=nch-1
       nch=0
       do i=1,nold
       if(sh(i:i).ne.' ')then
            nch=nch+1
            if(nch.ne.i)sh(nch:nch)=sh(i:i)
            if(sh(nch:nch).eq.'%')sh(nch:nch)=' '
       endif
       enddo
       end
